unit emulate;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Buttons, ToolWin, StdCtrls, Spin, ExtCtrls, Placemnt,utils;

type
 TTimePortRec = record
   Port: byte;
   Time: integer;
 end;  TEmulateForm = class(TForm)
    ToolBar1: TToolBar;
    PlayBtn: TSpeedButton;
    StatusBar1: TStatusBar;
    nVolEdit: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    TRedit: TSpinEdit;
    Label3: TLabel;
    PulseDurationEdit: TSpinEdit;
    Label4: TLabel;
    nD1Edit: TSpinEdit;
    Timer1: TTimer;
    StopBtn: TSpeedButton;
    FormStorage1: TFormStorage;
    procedure nVolEditChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer2Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
    function HourMinSecStr(lMSec: integer): string;

var
  EmulateForm: TEmulateForm;
  gCurrentOutput: integer;
implementation

uses par;

{$R *.DFM}
//function Out32(wAddr:word;bOut:byte):byte; stdcall; external 'inpout32.dll';
//function Inp32(wAddr:word):byte; stdcall; external 'inpout32.dll';

const
    kMaxEvents = 32000;
var gLastUpdateSec,gDurationMS,gStartTime: DWord;
    gnEvents,gEvent,gnScannerPulses,gScannerPulses: integer;
    gEventRA: array [1..kMaxEvents] of TTimePortRec;


function HourMinSecStr(lMSec: integer): string;
var lVal,lHour,lMin,lSec: integer;
  lMinStr,lSecStr,lMSecStr: string;
const
     kSecPerMin = 60;
     kSecPerHour = 60 * kSecPerMin;
begin
     lVal := lMSec div 1000; //number of seconds
     lHour := lVal div kSecPerHour;
     lVal := lVal - (lHour * kSecPerHour);
     lMin := lVal div kSecPerMin;
     lSec := lVal - (lMin * kSecPerMin);
     lSecStr := inttostr(lSec);

     lMSecStr := inttostr(lMSec mod 1000);

     if Length(lSecStr) < 2 then
        lSecStr := '0'+lSecStr;
     lMinStr := inttostr(lMin);
     if Length(lMinStr) < 2 then
        lMinStr := '0'+lMinStr;
     result := inttostr(lHour)+':'+lMinStr+':'+lSecStr+'.'+lMSecStr
end;


procedure TEmulateForm.nVolEditChange(Sender: TObject);
var lDurationMS {,lDurationSec} : integer;
begin
     lDurationMS := (nVolEdit.value-1)*TRedit.value;
     StatusBar1.Panels[0].text := 'Duration:'+HourMinSecStr(lDurationMS);
     //lDurationSec :=  lDurationMS div 1000;
     //StatusBar1.Panels[0].text := 'Session duration: '+inttostr(lDurationSec)+'s';
end;

procedure TEmulateForm.Timer1Timer(Sender: TObject);
var
  lMSec : integer;
begin
     lMSec := GetTickCount-gStartTime;
     if gEventRA[gEvent].Time < lMSec then begin
          gCurrentOutput := gEventRA[gEvent].Port;
          Out32x($378,gEventRA[gEvent].Port);
          MainForm.Memo1.Lines.Add(inttostr(gEvent)+':'+inttostr(gEventRA[gEvent].Port)+'@'+inttostr(gEventRA[gEvent].Time));
          inc(gEvent);
     end;
     if (gEvent > gnEvents) then begin
          Out32x($378,0);
          gCurrentOutput := 0;
          Timer1.Enabled := false;
          StatusBar1.Panels[0].text := 'Session Complete';
          StopBtn.Down := true;
     end;
     if (lMSec div 1000) > gLastUpdateSec then begin
        gLastUpdateSec := lMSec div 1000;
        StatusBar1.Panels[1].text := HourMinSecStr(gDurationMS - (lMSec));
     end;
     {inc(gScannerPulses);
     Out32($378,1);
     Timer2.Enabled := true;
     StatusBar1.Panels[0].text := inttostr(gScannerPulses);
     if gScannerPulses >= gnScannerPulses then begin
        Timer1.Enabled := false;
        StatusBar1.Panels[0].text := 'Session completed';
        StopBtn.Down := true;
     end;
     StatusBar1.Panels[1].text := HourMinSecStr(gDurationMS - (GetTickCount-gStartTime));}
end;

procedure SequenceEvents;
const
 kMaxEvents = 32000;
 kOutputlines = 4;
 kBitVal: array [0..kOutputlines] of integer = (1,2,4,8,16);
var
 lChangeBits,lOutput,lEvents,lBit,lTime,lI,lPos,lPulseDur,lInterPulseDur: integer;
 lDra: array [0..kOutputlines,1..kMaxEvents] of integer;
 lDPos,lDnum: array [0..kOutputlines] of integer;

 lDOn: array [0..kOutputlines] of boolean;
begin
  lPulseDur := EmulateForm.PulseDurationEdit.Value;
  lInterPulseDur := EmulateForm.TREdit.value-lPulseDur;
  lDnum[0] := gnScannerPulses * 2;
  lPos := 0;
  lTime := 0;
  for lI := 1 to gnScannerPulses do begin
      inc(lPos);
      lDra[0,lPos] := lTime;
      lTIme := lTime + lPulseDur;
      inc(lPos);
      lDra[0,lPos] := lTime;
      lTIme := lTime + lInterPulseDur;
  end;
  for lBit := 1 to 1 {kOutputlines} do begin
      lEvents := EmulateForm.nD1Edit.Value;
      {Case lBit of
           1: lEvents := EmulateForm.nD1Edit.Value;
           2: lEvents := EmulateForm.nD2Edit.Value;
           3: lEvents := EmulateForm.nD3Edit.Value;
           4: lEvents := EmulateForm.nD4Edit.Value;
           else lEvents := EmulateForm.nD5Edit.Value;
      end;{}
      if lEvents > 0 then begin
         lInterPulseDur := round(gDurationMS/(lEvents+1))-lPulseDur;
         if lInterPulseDur > 9 then begin //allow some gap between events
            lDnum[lBit] := lEvents * 2;
            lPos := 0;
            lTime := lInterPulseDur;
            for lI := 1 to lEvents do begin
                inc(lPos);
                lDra[lBit,lPos] := lTime;
                //showmessage(inttostr(lTime));
                lTIme := lTime + lPulseDur;
                inc(lPos);
                lDra[lBit,lPos] := lTime;
                lTIme := lTime + lInterPulseDur;
            end; //for each event
         end else begin//if gap between events
                  EmulateForm.StatusBar1.Panels[2].text := 'D'+inttostr(lBit)+' ignored: no time for gaps';
         end; //else no gap between events
      end; //if at least one event
  end; //for each output line

  for lBit := 0 to kOutputlines do begin
      lDOn[lBit] := false;
      lDpos[lBit] := 1;
  end;
  lOutput := 0;
  lTime := 0;
  gEvent := 0;
  repeat
       lChangeBits := 0;

       for lBit := 0 to 1 {kOutputlines} do begin
           if (lDnum[lBit] > 0) and (lDra[lBit,lDpos[lBit]] = lTime) then begin
              if lBit = 0 then
                 lChangeBits := 1
              else begin
                  if lOutPut > 1 then
                     lChangeBits := lOutput - (lOutPut and 1)
                  else
                      lChangeBits := {kBitVal[lBit]}(random(7)*2)+2;
              end;
              if (lOutput and lChangeBits) > 0 then
                 lOutput := lOutput - lChangeBits
              else
                  lOutput := lOutput + lChangeBits;
              inc(lDpos[lBit]);
           end; //this lines changes at this timepoint
       end; //check each line
       if lChangeBits > 0 then begin
           inc(gEvent);
           gEventRA[gEvent].Time := lTime;
           gEventRA[gEvent].Port := lOutput;
       end;
       inc(lTime);
  until lTIme > (gDurationMS+lPulseDur);
  gnEvents := gEvent;
end;

procedure TEmulateForm.PlayBtnClick(Sender: TObject);
begin
     if  (TRedit.value-10) < (PulseDurationEdit.value) then
        PulseDurationEdit.value := TRedit.value div 2;
     //Timer1.interval := TRedit.value;
     //Timer2.interval := PulseDurationEdit.value;
     nVolEditChange(nil);
     gDurationMS := (nVolEdit.value-1)*TRedit.value;
     gnScannerPulses := nVolEdit.value;
     //start: set up event onsets/offsets
     SequenceEvents;
     //end: onset/offsets
     gEvent := 1;
     gLastUpdateSec := 0;
     gScannerPulses := 0;
     MainForm.Memo1.Lines.Clear;
     gStartTime := getTickCount;
     Timer1.OnTimer(nil);
     Timer1.Enabled := true;
end;

procedure TEmulateForm.StopBtnClick(Sender: TObject);
begin
     Timer1.Enabled := false;
     gCurrentOutput := 0;
     StatusBar1.Panels[0].text := 'Session aborted';
end;

procedure TEmulateForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     Timer1.enabled := false;
end;

procedure TEmulateForm.Timer2Timer(Sender: TObject);
begin
     Out32x($378,0);
     //Timer2.Enabled := false;

end;

procedure TEmulateForm.FormCreate(Sender: TObject);
begin
     gCurrentOutput := 0;
end;

end.
